Subject: Cygwin, ssh, and top
From: "David Christensen" <[email-masked]>
To: <[email-masked]>
Cc: <[email-masked]>
Date: Sat, 15 Oct 2005 15:39:27 -0700

debian-user:

I've been chasing a problem with Cygwin ssh and Debian 3.1 top.  Here's my
original posting to debian-user:

-----Original Message-----
From: David Christensen [mailto:[email-masked]] 
Sent: Friday, June 10, 2005 9:13 PM
To: [email-masked]'
Subject: Cygwin, ssh, and top

debian users:

When I ssh into one of my Debian 3.0 boxes from WinXP Pro/ Cygwin, top works as
expected.

When I ssh into my Debian 3.1 box from WinXP Pro/Cygwin, top seems to be
inserting multiple line feeds at the end of each line:

   4 root       5 -10     0    0    0 S  0.0  0.0   0:00.01 khelper

  20 root       5 -10     0    0    0 S  0.0  0.0   0:00.00 kblockd/0

  44 root      15   0     0    0    0 S  0.0  0.0   0:01.44 pdflush

  46 root       5 -10     0    0    0 S  0.0  0.0   0:00.00 aio/0

  45 root      15   0     0    0    0 S  0.0  0.0   0:00.75 kswapd0

 182 root      25   0     0    0    0 S  0.0  0.0   0:00.00 kseriod

 202 root       6 -10     0    0    0 S  0.0  0.0   0:00.00 ata/0

1040 root      15   0     0    0    0 S  0.0  0.0   0:00.00 khubd

1840 root      15   0  2376  864 2164 S  0.0  0.3   0:00.00 dhclient

1846 daemon    16   0  1612  460 1440 S  0.0  0.2   0:00.00 portmap

2181 root      16   0  2260  820 2092 S  0.0  0.3   0:00.02 syslogd

Any ideas?

TIA,

David

The replies I received and the troubleshooting I did made me think that the
problem was with Cygwin.  So, I posted to the Cygwin list:

-----Original Message-----
From: David Christensen [mailto:[email-masked]] 
Sent: Friday, October 14, 2005 5:46 PM
To: [email-masked]
Subject: problems with top using Cygwin ssh to Debian 31r0a

Cygwin:

When I use Cygwin to ssh into a Debian 3.1 stable ("Sarge") machine and run
"top", the newlines seem to be double-expanded -- e.g. there is a blank line
between each line of information.  This problem does not occur when I ssh into a
Debian 3.0 stable ("Woody") machine.  This problem does not occur on either
Debian machine if I use Putty.

Any suggestions?

TIA,

David

The replies I received and troubleshooting I've done now tell me it's really a
Debian 3.1 problem.

Here are my latest efforts:

1.  Cygwin ssh TERM is cygwin on both Debian machines.

2.  Putty TERM is xterm.

3.  Setting Cygwin TERM to xterm and logging in to either Debian machine has no
effect on top, and now the cursor keys are broken.

4.  Here is infocmp output on Debian 3.0:

dpchrist@p166d302:~$ infocmp cygwin
#       Reconstructed via infocmp from file: /usr/share/terminfo/c/cygwin
cygwin|ansi emulation for Cygwin,
        am, eo, in, msgr, xon,
        colors#8, cols#80, it#8, lines#25, ncv#3, pairs#64,
 
acsc=+\020\,\021-\030.^Y0\333`\004a\261f\370g\361h\260j\331k\277l\332m\300n\305o
~p\304q\304r\304s_t\303u\264v\301w\302x\263y\363z\362{\343|\330}\234~\376,
        bel=^G, bold=\E[1m, clear=\E[H\E[J, cr=^M, cub1=^H,
        cud1=\E[B, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH, cuu1=\E[A,
        dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, ed=\E[J,
        el=\E[K, el1=\E[1K, home=\E[H, hpa=\E[%i%p1%dG, ht=^I,
        hts=\EH, ich=\E[%p1%d@, ich1=\E[@, il=\E[%p1%dL, il1=\E[L,
        ind=^J, invis=\E[8m, kbs=^H, kcub1=\E[D, kcud1=\E[B,
        kcuf1=\E[C, kcuu1=\E[A, kdch1=\E[3~, kend=\E[4~, kf1=\E[[A,
        kf10=\E[21~, kf11=\E[23~, kf12=\E[24~, kf13=\E[25~,
        kf14=\E[26~, kf15=\E[28~, kf16=\E[29~, kf17=\E[31~,
        kf18=\E[32~, kf19=\E[33~, kf2=\E[[B, kf20=\E[34~,
        kf3=\E[[C, kf4=\E[[D, kf5=\E[[E, kf6=\E[17~, kf7=\E[18~,
        kf8=\E[19~, kf9=\E[20~, khome=\E[1~, kich1=\E[2~,
        knp=\E[6~, kpp=\E[5~, kspd=^Z, nel=^M^J, op=\E[39;49m,
        rc=\E8, rev=\E[7m, ri=\EM, rmir=\E[4l, rmpch=\E[10m,
        rmso=\E[27m, rmul=\E[24m, rs1=\Ec\E]R, sc=\E7,
        setab=\E[4%p1%dm, setaf=\E[3%p1%dm,
 
sgr=\E[0;10%?%p1%t;7%;%?%p2%t;4%;%?%p3%t;7%;%?%p4%t;5%;%?%p6%t;1%;%?%p7%t;8%;%?%
p9%t;11%;m,
        sgr0=\E[0;10m, smir=\E[4h, smpch=\E[11m, smso=\E[7m,
        smul=\E[4m, u6=\E[%i%d;%dR, u7=\E[6n, u9=\E[c,
        vpa=\E[%i%p1%dd,
dpchrist@p166d302:~$

5. Here is infocmp output on Debian 3.1:

dpchrist@p166v:~$ infocmp cygwin
#       Reconstructed via infocmp from file: /etc/terminfo/c/cygwin
cygwin|ansi emulation for Cygwin,
        am, hs, in, msgr, xon,
        colors#8, it#8, pairs#64,
 
acsc=+\020\,\021-\030.^Y0\333`\004a\261f\370g\361h\260j\331k\277l\332m\300n\305o
~p\304q\304r\304s_t\303u\264v\301w\302x\263y\363z\362{\343|\330}\234~\376,
        bel=^G, bold=\E[1m, cbt=\E[Z, clear=\E[H\E[J, cr=^M,
        cub=\E[%p1%dD, cub1=^H, cud=\E[%p1%dB, cud1=\E[B,
        cuf=\E[%p1%dC, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH,
        cuu=\E[%p1%dA, cuu1=\E[A, dch=\E[%p1%dP, dch1=\E[P,
        dl=\E[%p1%dM, dl1=\E[M, ed=\E[J, el=\E[K, el1=\E[1K, fsl=^G,
        home=\E[H, hpa=\E[%i%p1%dG, ht=^I, ich=\E[%p1%d@,
        ich1=\E[@, il=\E[%p1%dL, il1=\E[L, ind=^J, invis=\E[8m,
        kb2=\E[G, kbs=^H, kcub1=\E[D, kcud1=\E[B, kcuf1=\E[C,
        kcuu1=\E[A, kdch1=\E[3~, kend=\E[4~, kf1=\E[[A,
        kf10=\E[21~, kf11=\E[23~, kf12=\E[24~, kf13=\E[25~,
        kf14=\E[26~, kf15=\E[28~, kf16=\E[29~, kf17=\E[31~,
        kf18=\E[32~, kf19=\E[33~, kf2=\E[[B, kf20=\E[34~,
        kf3=\E[[C, kf4=\E[[D, kf5=\E[[E, kf6=\E[17~, kf7=\E[18~,
        kf8=\E[19~, kf9=\E[20~, khome=\E[1~, kich1=\E[2~,
        knp=\E[6~, kpp=\E[5~, kspd=^Z, nel=^M^J, op=\E[39;49m,
        rc=\E8, rev=\E[7m, ri=\EM, rmacs=\E[10m,
        rmcup=\E[2J\E[?47l\E8, rmir=\E[4l, rmpch=\E[10m,
        rmso=\E[27m, rmul=\E[24m, rs1=\Ec\E]R, sc=\E7,
        setab=\E[4%p1%dm, setaf=\E[3%p1%dm,
 
sgr=\E[0;10%?%p1%t;7%;%?%p2%t;4%;%?%p3%t;7%;%?%p4%t;5%;%?%p6%t;1%;%?%p7%t;8%;%?%
p9%t;11%;m,
        sgr0=\E[0;10m, smacs=\E11m, smcup=\E7\E[?47h, smir=\E[4h,
        smpch=\E[11m, smso=\E[7m, smul=\E[4m, tsl=\E];,
        u6=\E[%i%d;%dR, u7=\E[6n, u8=\E[?6c, u9=\E[c,
        vpa=\E[%i%p1%dd,

6. Here is the difference:

<CVSENV>dpchrist@p42800e:~/mydocuments/cygwin$ diff -d debian-30-infocmp.out de
bian-31-infocmp.out
1c1
< #     Reconstructed via infocmp from file: /usr/share/terminfo/c/cygwin
---
> #     Reconstructed via infocmp from file: /etc/terminfo/c/cygwin
3,4c3,4
<       am, eo, in, msgr, xon,
<       colors#8, cols#80, it#8, lines#25, ncv#3, pairs#64,
---
>       am, hs, in, msgr, xon,
>       colors#8, it#8, pairs#64,
6,12c6,14
<       bel=^G, bold=\E[1m, clear=\E[H\E[J, cr=^M, cub1=^H,
<       cud1=\E[B, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH, cuu1=\E[A,
<       dch=\E[%p1%dP, dch1=\E[P, dl=\E[%p1%dM, dl1=\E[M, ed=\E[J,
<       el=\E[K, el1=\E[1K, home=\E[H, hpa=\E[%i%p1%dG, ht=^I,
<       hts=\EH, ich=\E[%p1%d@, ich1=\E[@, il=\E[%p1%dL, il1=\E[L,
<       ind=^J, invis=\E[8m, kbs=^H, kcub1=\E[D, kcud1=\E[B,
<       kcuf1=\E[C, kcuu1=\E[A, kdch1=\E[3~, kend=\E[4~, kf1=\E[[A,
---
>       bel=^G, bold=\E[1m, cbt=\E[Z, clear=\E[H\E[J, cr=^M,
>       cub=\E[%p1%dD, cub1=^H, cud=\E[%p1%dB, cud1=\E[B,
>       cuf=\E[%p1%dC, cuf1=\E[C, cup=\E[%i%p1%d;%p2%dH,
>       cuu=\E[%p1%dA, cuu1=\E[A, dch=\E[%p1%dP, dch1=\E[P,
>       dl=\E[%p1%dM, dl1=\E[M, ed=\E[J, el=\E[K, el1=\E[1K, fsl=^G,
>       home=\E[H, hpa=\E[%i%p1%dG, ht=^I, ich=\E[%p1%d@,
>       ich1=\E[@, il=\E[%p1%dL, il1=\E[L, ind=^J, invis=\E[8m,
>       kb2=\E[G, kbs=^H, kcub1=\E[D, kcud1=\E[B, kcuf1=\E[C,
>       kcuu1=\E[A, kdch1=\E[3~, kend=\E[4~, kf1=\E[[A,
19c21,22
<       rc=\E8, rev=\E[7m, ri=\EM, rmir=\E[4l, rmpch=\E[10m,
---
>       rc=\E8, rev=\E[7m, ri=\EM, rmacs=\E[10m,
>       rmcup=\E[2J\E[?47l\E8, rmir=\E[4l, rmpch=\E[10m,
23,24c26,28
<       sgr0=\E[0;10m, smir=\E[4h, smpch=\E[11m, smso=\E[7m,
<       smul=\E[4m, u6=\E[%i%d;%dR, u7=\E[6n, u9=\E[c,
---
>       sgr0=\E[0;10m, smacs=\E11m, smcup=\E7\E[?47h, smir=\E[4h,
>       smpch=\E[11m, smso=\E[7m, smul=\E[4m, tsl=\E];,
>       u6=\E[%i%d;%dR, u7=\E[6n, u8=\E[?6c, u9=\E[c,

Clearly, there are many differences between the infocmp reports for Debian 3.0
and 3.1.  I don't know which of all those escape codes (?) is the root cause of
the problem, but one (or more) of them must be.  I am hesitant to take
/etc/terminfo/c/cygwin on a Debian 3.0 machine and blindly step on its successor
in my Debian 3.1 machines.

Does anybody know how to fix this problem?  Do I need to figure out which
package the terminfo stuff comes from and file a bug report?

TIA,

David

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/